/**
 * @file i2c.h
 *
 * @brief This file contains the definitions for I2C functions for
 *        the I2C-MP-USB firmware project.
 *
 * @author Thomas Fischl
 * @copyright (c) 2017-2019 Thomas Fischl
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 * 
 */
#ifndef I2C_H
#define	I2C_H

#define _XTAL_FREQ 48000000
#define I2C_DEFAULT_PERIOD_US 10 // -> 100kHz
#define I2C_BRG_CORRECTION 6 // measured correction factor (nowhere documented?)

void i2c_init();
void i2c_setBaudratePeriod(unsigned short period);
void i2c_setBaudrate(unsigned short baudrate);
unsigned char i2c_start();
unsigned char i2c_repeatedStart();
unsigned char i2c_sendByte(unsigned char b);
unsigned char i2c_receiveByte(unsigned char * b, unsigned char ack);
unsigned char i2c_stop(void);


#endif	/* I2D_H */

